diff --git a/gdb/ada-lang.c b/gdb/ada-lang.c
index 622cf59de68..fddb0d7278c 100644
--- a/gdb/ada-lang.c
+++ b/gdb/ada-lang.c
@@ -14380,7 +14380,8 @@ extern const struct language_defn ada_language_defn = {
   default_search_name_hash,
   &ada_varobj_ops,
   NULL,
-  NULL
+  NULL,
+  "(...)"			/* la_struct_too_deep_ellipsis */
 };
 
 /* Command-list for the "set/show ada" prefix command.  */
diff --git a/gdb/c-lang.c b/gdb/c-lang.c
index 33506f1d1ed..3be5ef57252 100644
--- a/gdb/c-lang.c
+++ b/gdb/c-lang.c
@@ -873,7 +873,8 @@ extern const struct language_defn c_language_defn =
   default_search_name_hash,
   &c_varobj_ops,
   c_get_compile_context,
-  c_compute_program
+  c_compute_program,
+  "{...}"			/* la_struct_too_deep_ellipsis */
 };
 
 enum cplus_primitive_types {
@@ -1017,7 +1018,8 @@ extern const struct language_defn cplus_language_defn =
   cp_search_name_hash,
   &cplus_varobj_ops,
   cplus_get_compile_context,
-  cplus_compute_program
+  cplus_compute_program,
+  "{...}"			/* la_struct_too_deep_ellipsis */
 };
 
 static const char *asm_extensions[] =
@@ -1070,7 +1072,8 @@ extern const struct language_defn asm_language_defn =
   default_search_name_hash,
   &default_varobj_ops,
   NULL,
-  NULL
+  NULL,
+  "{...}"			/* la_struct_too_deep_ellipsis */
 };
 
 /* The following language_defn does not represent a real language.
@@ -1123,5 +1126,6 @@ extern const struct language_defn minimal_language_defn =
   default_search_name_hash,
   &default_varobj_ops,
   NULL,
-  NULL
+  NULL,
+  "{...}"			/* la_struct_too_deep_ellipsis */
 };
diff --git a/gdb/d-lang.c b/gdb/d-lang.c
index 08b638009ff..751c521a75d 100644
--- a/gdb/d-lang.c
+++ b/gdb/d-lang.c
@@ -250,7 +250,8 @@ extern const struct language_defn d_language_defn =
   default_search_name_hash,
   &default_varobj_ops,
   NULL,
-  NULL
+  NULL,
+  "{...}"			/* la_struct_too_deep_ellipsis */
 };
 
 /* Build all D language types for the specified architecture.  */
diff --git a/gdb/f-lang.c b/gdb/f-lang.c
index f3a806e7a6f..77eb50a0761 100644
--- a/gdb/f-lang.c
+++ b/gdb/f-lang.c
@@ -377,7 +377,8 @@ extern const struct language_defn f_language_defn =
   default_search_name_hash,
   &default_varobj_ops,
   NULL,
-  NULL
+  NULL,
+  "(...)"			/* la_struct_too_deep_ellipsis */
 };
 
 static void *
diff --git a/gdb/go-lang.c b/gdb/go-lang.c
index f74cee4ccd8..b8617cb162d 100644
--- a/gdb/go-lang.c
+++ b/gdb/go-lang.c
@@ -611,7 +611,8 @@ extern const struct language_defn go_language_defn =
   default_search_name_hash,
   &default_varobj_ops,
   NULL,
-  NULL
+  NULL,
+  "{...}"			/* la_struct_too_deep_ellipsis */
 };
 
 static void *
diff --git a/gdb/language.c b/gdb/language.c
index 954e4c200f0..da8dd1bf7ae 100644
--- a/gdb/language.c
+++ b/gdb/language.c
@@ -876,7 +876,8 @@ const struct language_defn unknown_language_defn =
   default_search_name_hash,
   &default_varobj_ops,
   NULL,
-  NULL
+  NULL,
+  "{...}"			/* la_struct_too_deep_ellipsis */
 };
 
 /* These two structs define fake entries for the "local" and "auto"
@@ -926,7 +927,8 @@ const struct language_defn auto_language_defn =
   default_search_name_hash,
   &default_varobj_ops,
   NULL,
-  NULL
+  NULL,
+  "{...}"			/* la_struct_too_deep_ellipsis */
 };
 
 
diff --git a/gdb/language.h b/gdb/language.h
index 3e0bc9d0d46..261f5a33cc7 100644
--- a/gdb/language.h
+++ b/gdb/language.h
@@ -449,6 +449,12 @@ struct language_defn
 				       struct gdbarch *gdbarch,
 				       const struct block *expr_block,
 				       CORE_ADDR expr_pc);
+
+    /* This string is used by the 'set print max-depth' setting.  When GDB
+       replaces a struct or union (during value printing) that is "too
+       deep" this string is displayed instead.  */
+    const char *la_struct_too_deep_ellipsis;
+
   };
 
 /* Pointer to the language_defn for our current language.  This pointer
diff --git a/gdb/m2-lang.c b/gdb/m2-lang.c
index b4eb2628571..9f2a97d54fd 100644
--- a/gdb/m2-lang.c
+++ b/gdb/m2-lang.c
@@ -398,7 +398,8 @@ extern const struct language_defn m2_language_defn =
   default_search_name_hash,
   &default_varobj_ops,
   NULL,
-  NULL
+  NULL,
+  "{...}"			/* la_struct_too_deep_ellipsis */
 };
 
 static void *
diff --git a/gdb/objc-lang.c b/gdb/objc-lang.c
index 1853a69e754..af92e55a437 100644
--- a/gdb/objc-lang.c
+++ b/gdb/objc-lang.c
@@ -408,7 +408,8 @@ extern const struct language_defn objc_language_defn = {
   default_search_name_hash,
   &default_varobj_ops,
   NULL,
-  NULL
+  NULL,
+  "{...}"			/* la_struct_too_deep_ellipsis */
 };
 
 /*
diff --git a/gdb/opencl-lang.c b/gdb/opencl-lang.c
index c1ea66eea39..c95bf05a98b 100644
--- a/gdb/opencl-lang.c
+++ b/gdb/opencl-lang.c
@@ -1086,7 +1086,8 @@ extern const struct language_defn opencl_language_defn =
   default_search_name_hash,
   &default_varobj_ops,
   NULL,
-  NULL
+  NULL,
+  "{...}"			/* la_struct_too_deep_ellipsis */
 };
 
 static void *
diff --git a/gdb/p-lang.c b/gdb/p-lang.c
index 9340861761b..0b85f70dfd2 100644
--- a/gdb/p-lang.c
+++ b/gdb/p-lang.c
@@ -459,5 +459,6 @@ extern const struct language_defn pascal_language_defn =
   default_search_name_hash,
   &default_varobj_ops,
   NULL,
-  NULL
+  NULL,
+  "{...}"			/* la_struct_too_deep_ellipsis */
 };
diff --git a/gdb/rust-lang.c b/gdb/rust-lang.c
index 9a123c338ef..8faafd49cdd 100644
--- a/gdb/rust-lang.c
+++ b/gdb/rust-lang.c
@@ -2141,5 +2141,6 @@ extern const struct language_defn rust_language_defn =
   default_search_name_hash,
   &default_varobj_ops,
   NULL,
-  NULL
+  NULL,
+  "{...}"			/* la_struct_too_deep_ellipsis */
 };